/* $Id: Fwt.java,v 1.17 2010/12/09 06:59:27 mit Exp $ */
/* wavelet.java v1.5 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class Fwt extends Applet 
    implements ActionListener, AdjustmentListener, ItemListener
{
    private Scrollbar scWave;    // position
    private Button btGM, btGP;   // -,+ (gain)
    private Button btSM, btSP;   // <,> 
    private Button btWave;
    private Button btFwt;
    private Choice chFile;       // files
    private Choice chWlet;       // wavelet
    private Choice chMin;        // ֹ
    private Choice chWide;       // 
    private TextField tfA;
    private Canvas can;
    private Panel PU, PD, PL, PR;

    private FWT FW;
    private ReadWave RW;

    static final int WAVE = 0;
    static final int FWT_ = 1;
    static final int[] R = 
    {255,255,255,255,170, 90,  0,  0,  0,  0, 40, 90, 90,170,255};
    static final int[] G = 
    {  0, 90,170,255,255,255,170,170,170, 90,  0,  0,  0,  0,  0};
    static final int[] B = 
    {  0,  0,  0,  0,  0,  0, 90,170,255,255,255,255,220,200,170};

    boolean CalSW;
    int W;
    int H;
    int H2;
    int FNT;
    int AF;        // all_files
    int SFT;       // left_side
    int Grap;      // ؤ#
    int M;         // 1024:10 2048:11 4096:12 8192:13
    int J = 12;    // 8000
    int Wno;       // wavelet#
    int Cnt;       // wave size
    int Splngf;    // sampling f
    int Band;      // Jι
    int Shift;     // Jγֹ
    int Wstart;    // waveɽϰ
    double Wgain;  // wave
    double Gain;   // wavelet
    String[] filename;
    String Error;
    String Dirnm;
    Color[] Octc;  // wavelet color

    DecimalFormat df1;
    Graphics gi;
    Image im;
    Font Fnt;
    FontMetrics fm;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
 	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	df1 = new DecimalFormat("#0.##");

	setBackground(Color.lightGray);
	setLayout(new BorderLayout());

	PU = new Panel();
	PU.setLayout(new FlowLayout());
	add("North", PU);

	tfA = new TextField(26);
	tfA.setEditable(false);
        PU.add(tfA);

 	String fn = getParameter("all_f");
        AF = (fn == null) ? 0 : Integer.parseInt(fn);
	if (AF == 0)
            Error = "No wave file.";
        filename = new String[AF];
	Dirnm = getParameter("dirnm");
        Dirnm = (Dirnm == null) ? "" : Dirnm;
	chFile = new Choice();
        for (int i = 0; i < AF; i++) {
            filename[i] = getParameter("wave"+i);
            chFile.addItem(filename[i]);
	}
        chFile.addItemListener(this);
        PU.add(chFile);

	FW = new FWT();
	chWlet = new Choice();            // mather wavelet
	for (int i = 0; i < FW.getWaveletsNum(); i++)
	    chWlet.addItem(FW.getWaveletsName(i));
	chWlet.select(Wno);
 	chWlet.addItemListener(this);
 	PU.add(chWlet); 
	//------------------- north

	PD = new Panel();
	PD.setLayout(new GridLayout(1,3,0,0));
	add("South", PD);

	scWave = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 100);
	scWave.addAdjustmentListener(this);
	PD.add(scWave);
	//-------------------- south

	PL = new Panel();
	PL.setLayout(new GridLayout(6,1,0,0));
	add("West", PL);

	btWave = new Button("Wave");
	btWave.addActionListener(this);
	PL.add(btWave);

	btFwt = new Button("Fwt");
	btFwt.addActionListener(this);
	PL.add(btFwt);

	PL.add(new Label("Start:"));

	chMin = new Choice();
	for (int i = 1; i < J; i++) // 1~
	    chMin.addItem(""+i);
        chMin.addItemListener(this);
        PL.add(chMin);

	PL.add(new Label("Wide:"));

	chWide = new Choice();
	for (int i = 2; i < J; i++) // 2~
	    chWide.addItem(""+i);
	chWide.select(""+(J-1));
        chWide.addItemListener(this);
        PL.add(chWide);
	//------------------ west

	PR = new Panel();
	PR.setLayout(new GridLayout(5,1,0,0));
	add("East", PR);

	btGP = new Button("+");
        btGP.addActionListener(this);
        PR.add(btGP);

	btGM = new Button("-");
        btGM.addActionListener(this);
        PR.add(btGM);

	PR.add(new Label());

	btSM = new Button("<");
        btSM.addActionListener(this);
        PR.add(btSM);

	btSP = new Button(">");
        btSP.addActionListener(this);
        PR.add(btSP);
	//--------------- east

	can = new MyCanvas();
	add(can, "Center");

	init_start();
    }
    public void start() {
	W = getCanvasD().width;
	H = getCanvasD().height;

	H2 = H/2;
	can.setSize(W, H);
	im = createImage(W, H);
        gi = im.getGraphics();
        gi.setFont(Fnt);
	fm = getFontMetrics(Fnt);
	SFT = fm.stringWidth("(00000)");

	Gain = H/(double)Short.MAX_VALUE/50;
	Wgain = H/(double)Short.MAX_VALUE/2;
    }
    public Dimension getCanvasD() {
        Dimension dn = PU.getSize();
        Dimension ds = PD.getSize();
        Dimension de = PR.getSize();
	Dimension dw = PL.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height);
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_start() {
	M = (int)Math.pow(2, J);
	Band = J;
	Shift = 0;
	Wstart = 0;
	Wno = 1;
	Grap = WAVE;

	set_color();
	ch_wavelet();
	if (isFile())
	    read_file(filename[0]);
    }
    public boolean isFile() {
	return (AF > 0);
    }
    //
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == chFile)           // choice file
	    read_file(chFile.getSelectedItem());

	if (e.getSource() == chWlet) {         // choice wavelet
	    Wno = chWlet.getSelectedIndex();
	    ch_wavelet();
	}

	if (e.getSource() == chMin)
	    set_min();

	if (e.getSource() == chWide)
	    set_wide();

        can.repaint();
    }
    //
    public void adjustmentValueChanged(AdjustmentEvent e) {
	Wstart = scWave.getValue();
	can.repaint();
    }
    //
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btWave)
	    Grap = WAVE;
	else if (e.getSource() == btFwt)
	    Grap = FWT_;

	else if (e.getSource() == btSM) {   // scale
	    M /= 2;
	    set_m();
	}
	else if (e.getSource() == btSP) {
	    M *= 2;
	    set_m();
	}

	else if (e.getSource() == btGM)   // gain
	    set_ga(false);
	else if (e.getSource() == btGP)
	    set_ga(true);

	can.repaint();
    }
    public void set_ga(boolean sw) {
	double sq2 = Math.sqrt(2);

	switch (Grap) {
	case WAVE:
	    Wgain = sw ? Wgain*sq2 : Wgain/sq2;
	    break;
	case FWT_:
	    Gain = sw ? Gain*sq2 : Gain/sq2;
	    break;
	default:
	}
    }
    public void set_sp() {
	if (Splngf > 44000)
	    J = 15;
	else if (Splngf > 22000)
	    J = 14;
	else if (Splngf > 11000)
	    J = 13;
	else
	    J = 12;

	set_min();
	set_wide();
	M = (int)Math.pow(2, J);
	set_m();
    }
    public void set_m() {
	if (!isFile())
	    return;

	if (M < 1000) {
	    M = (int)Math.pow(2, 10); //1024;
	    btSM.setEnabled(false);
	} else if (M > Cnt) {
	    calc_m();
	    btSP.setEnabled(false);
	} else {
	    btSM.setEnabled(true);
	    btSP.setEnabled(true);
	}

	set_scwave();
    }
    public void calc_m() {
	while (M > Cnt) {
	    M /= 2;

	    if (M < 1) {
		Error = "M error.";
		break;
	    }
	}
    }
    public void set_scwave() {
	int val = scWave.getValue();
	if (val >= M)
	    val = 0;
	scWave.setValues(val, M, 0, Cnt);
	scWave.setBlockIncrement(M);
	scWave.setUnitIncrement(M/2);
    }
    public void set_wide() {
	Band = chWide.getSelectedIndex()+2;
    }
    public void set_min() {
	Shift = chMin.getSelectedIndex();
    }
    public void ch_wavelet() {
	FW.setFWT(Wno);

	CalSW = false;
    }
    public double set_gain(int j) {
	double by = j+1;          // daub
	if (Wno > 9)
	    by = Math.pow(2,j)*2; // symlet
	else if (Wno > 4)
	    by = 1;               // coiflet

	return Gain*8/by;
    }
    public void read_file(String fname) {
	read_wave(Dirnm+fname);

	if (Error == "") {
	    Wstart = 0;
	    scWave.setValue(Wstart);
	    set_sp();

	    CalSW = false;
	}
    }
    public void read_wave(String fn) {
	try {
            URL url = new URL(getDocumentBase(), fn);
            RW = new ReadWave(url);
            Splngf = RW.getSamplf();
            Cnt = RW.getCount();
            Error = RW.getError();
        } catch(Exception e) {
            Error = "File read error.";
        }
    }
    public void write_tfa() {
	StringBuffer str = new StringBuffer();

	if (!Error.equals(""))
	    str.append(Error);
	else {
	    switch (Grap) {
	    case WAVE:
		str.append(Splngf+"[Hz] ");
		str.append(df1.format(Cnt/(double)Splngf)+"[sec]:");
		str.append(RW.getLavel());
		break;
	    case FWT_:
		str.append(100*M/Cnt+"% (");
		str.append(M+"/"+Cnt+")");
		break;
	    default:
	    }
	}

	tfA.setText(str.toString());
    }
    public String dform(double nm) {
        return df1.format((float)nm);
    }
    //-----

    class MyCanvas extends Canvas {
        public void update(Graphics g) {
            can.paint(g);
        }
	public void paint(Graphics g) {
	    paintI();
            g.drawImage(im, 0, 0, this);
        }
    }
    public void set_color() {
	Octc = new Color[G.length];
	for (int i = 0; i < G.length; i++)
	    Octc[i] = new Color(R[i], G[i], B[i]);
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);

	write_tfa();
	disp_sft_line(gi);

	switch (Grap) {
	case WAVE:
	    disp_wave(gi);
	    break;
	case FWT_:
	    if (isFile() || CalSW == false) {
		FW.wavelet(RW.getData(), M, J, Wstart);
		CalSW = true;
	    }
	    disp_wavelet(gi);
	    disp_smpl(gi);
	    break;
	default:
	}
    }
    //
    public void disp_smpl(Graphics g) {
	g.setColor(Color.yellow);
	g.drawString(""+Splngf, 2, FNT);
    }
    public void disp_wavelet(Graphics g) {
	int h0 = H/Band;
	int ba = Band+Shift;
	if (ba > J) {
	    ba = J;
	    h0 = H/(J-Shift);
	}

	int sj = Splngf/(int)Math.pow(2, Shift+1);
	int lj, x1, y1, h1 = 0;
	double dx, ga;
	for(int j = Shift; j < ba; j++) {
	    lj = M/(int)Math.pow(2, j+1);
	    dx = (double)(W-SFT)/lj;
	    h1 += h0;
	    sj /= 2;
	    disp_j_line(g, j, sj, h1);

	    if (isFile()) {          // disp wavelet
		g.setColor(Octc[j]);
		ga = set_gain(j);
		for(int i = 0; i < lj; i++) {
		    x1 = (int)(SFT+i*dx);
		    y1 = (int)(h1-FW.getData(i+lj)*ga);
		    g.drawLine(x1, h1, x1, y1);
		}
	    }
	}
    }
    public void disp_j_line(Graphics g, int j, int sj, int h1) {
	    g.setColor(Color.white);       // J
	    g.drawString("J "+(j+1), 3, h1-3);

	    g.setColor(Color.orange);      // octave
	    g.drawString(sj+"", 2, h1+FNT);

	    g.setColor(Color.gray);        // line
	    g.drawLine(0, h1, W, h1);
    }
    public void disp_sft_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(SFT, 0, SFT, H);
    }
    //
    public void disp_wave(Graphics g) {
	disp_time(g);

	int x, y, val, max = Integer.MIN_VALUE, min = Integer.MAX_VALUE;
	double dw = (W-SFT)/(double)M;
	g.setColor(Color.green);
	for(int i = 0; i < M; i++) {
	    val = RW.getData(i+Wstart);
	    x = (int)(SFT+dw*i);
	    y = (int)(H2-val*Wgain);
	    g.drawLine(x, y, x, y);
	    max = Math.max(max, (int)val);
            min = Math.min(min, (int)val);
	}

	disp_wave_value(g, min, max);
    }
    public void disp_wave_value(Graphics g, int min, int max) {
        g.setColor(Color.lightGray);
        g.drawString(dform(100.0*max/Short.MAX_VALUE), 1, (int)(H2-max*Wgain));
        g.drawString(dform(100.0*min/Short.MIN_VALUE), 1, (int)(H2-min*Wgain+FNT));
        g.drawString("[%]", 1, FNT);
    }
    public void disp_time(Graphics g) {
        double tim, allsec = M/(double)Splngf;

        if (allsec < 0.1)
            tim = 0.01;
        else if (allsec < 0.3)
            tim = 0.05;
        else if (allsec < 1)
            tim = 0.1;
        else if (allsec < 3)
            tim = 0.5;
        else if (allsec < 10)
            tim = 1;
        else if (allsec < 30)
            tim = 5;
        else if (allsec < 60)
            tim = 10;
        else
            tim = 60;

        int bs = H-FNT*3;
        g.setColor(Color.gray);
        g.drawLine(SFT, bs, W, bs); // base line 
        g.drawLine(SFT, H2, W, H2); // center line
        String s = "[sec] ";
        g.setColor(Color.yellow);
        g.drawString(s, W-fm.stringWidth(s), H-1);

        double asec = tim/(allsec/(W-SFT));
        int maxsec = (int)(allsec/tim);
        if (maxsec > 0) {
            int ss = H-FNT;  // ʸh
            int x, l = 5;
            for (int i = 0; i <= maxsec; i++) {
                x = (int)(SFT+asec*i);

                g.setColor(Color.gray);
                g.drawLine(x, bs, x, bs+l);

                g.setColor(Color.yellow);
                g.drawString(dform(i*tim), x, ss);
            }
        }
    }
}